#include "MeterWpfWrapper.h"
//#include "NativeInterface.h"
//
#include <windows.h>
#include <WinUser.h>
//
#include <msclr\auto_gcroot.h>
//
//#using "C:\Users\john_\Documents\VST_SDK_3.6.14\VST3_SDK\build_x64\bin\Debug\Meter_WPF_UI_CS_XAML_AnyCPU.dll"
#using "C:\Program Files\Common Files\VST3\Carlsound\MeterTestWPF\Meter_WPF_UI_CS_XAML_AnyCPU.dll"

//////////////////////////////////////////////

namespace Carlsound
{
	namespace MeterTest
	{
		class MeterWpfWrapperPrivate
		{
		public:
			msclr::auto_gcroot<System::Windows::Interop::HwndSourceParameters^>* m_hwndSourceParams;
			msclr::auto_gcroot<System::Windows::Interop::HwndSource^>* m_hwndSource;
			msclr::auto_gcroot<MeterUserControl^>* m_meterUserControl;
		};

		//////////////////////////////////////////////

		MeterWpfWrapper::MeterWpfWrapper(void* hWnd)
		{
			if(_WIN64)
			{
				System::Reflection::Assembly::Load("C:\Program Files\Common Files\VST3\Carlsound\MeterTestWPF\Meter_WPF_UI_CS_XAML_AnyCPU.dll");
			}
			else
			{
				System::Reflection::Assembly::Load("C:\Program Files (x86)\Common Files\VST3\Carlsound\MeterTestWPF\Meter_WPF_UI_CS_XAML_AnyCPU.dll");
			}
			//
			m_private = new MeterWpfWrapperPrivate();
			//
			*(m_private->m_meterUserControl) = gcnew MeterUserControl();
			//
			*(m_private->m_hwndSourceParams) = gcnew System::Windows::Interop::HwndSourceParameters("Meter");
			m_private->m_hwndSourceParams->get()->PositionX = 0;
			m_private->m_hwndSourceParams->get()->PositionY = 0;
			m_private->m_hwndSourceParams->get()->Height = 100; //m_userControl->Height;
			m_private->m_hwndSourceParams->get()->Width = 300; // m_userControl->Width;
			m_private->m_hwndSourceParams->get()->ParentWindow = System::IntPtr(hWnd);
			m_private->m_hwndSourceParams->get()->WindowStyle = WS_VISIBLE | WS_CHILD;
			//
			*(m_private->m_hwndSource) = gcnew System::Windows::Interop::HwndSource(*m_private->m_hwndSourceParams->get());
			//
			m_private->m_hwndSource->get()->RootVisual = m_private->m_meterUserControl->get();
		}

		//////////////////////////////////////////////

		MeterWpfWrapper::~MeterWpfWrapper()
		{
			delete m_private;
		}

		//////////////////////////////////////////////

		void MeterWpfWrapper::SetLevel(double newLevel)
		{
			m_private->m_meterUserControl->get()->SetLevel(newLevel);
		}
	}
}